<?php

function ckpn_admin_page() {
	$current = ckpn_get_options();
	if ( isset( $_GET['settings-updated'] ) && $current['plugin_updates'] == false && $timestamp = wp_next_scheduled( 'ckpn_plugin_update_check' ) ) {
		wp_unschedule_event( $timestamp, 'ckpn_plugin_update_check' );
	}
	?>
	<form method="post" action="options.php">
		<?php wp_nonce_field( 'ckpn-update-options' ); ?>
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><?php _e( 'Application API Token/Key', CKPN_CORE_TEXT_DOMAIN ); ?><br /><span style="font-size: x-small;"><?php _e( 'Available from within your Pushover Account', CKPN_CORE_TEXT_DOMAIN ); ?></span></th>
				<td>
				<input size="50" type="text" name="ckpn_pushover_notifications_settings[application_key]" placeholder="<?php _e( 'Enter Application Key', CKPN_CORE_TEXT_DOMAIN ); ?>" <?php if ( $current['application_key'] != '' ) {?>value="<?php echo htmlspecialchars( $current['application_key'] ); ?>"<?php ;}?> />
				<br />
				<?php _e( 'To Create an application visit <a href="https://pushover.net/apps" target="_blank">https://pushover.net/apps</a>', CKPN_CORE_TEXT_DOMAIN ); ?>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e( 'Your User Key', CKPN_CORE_TEXT_DOMAIN ); ?><br /><span style="font-size: x-small;"><?php _e( 'Available from within your Pushover Account', CKPN_CORE_TEXT_DOMAIN ); ?></span></th>
				<td>
				<input size="50" type="text" name="ckpn_pushover_notifications_settings[api_key]" placeholder="<?php _e( 'Enter User Key', CKPN_CORE_TEXT_DOMAIN ); ?>" <?php if ( $current['api_key'] != '' ) {?>value="<?php echo htmlspecialchars( $current['api_key'] ); ?>"<?php ;}?> /><br />
				<?php printf( __( 'This is the Administrator User Key. Other users can add their keys by editing their <a href="%s">Profile</a> under the \'Contact Info\' Section.', CKPN_CORE_TEXT_DOMAIN ), admin_url( 'profile.php' ) ); ?>
				<br />
				<?php _e( 'Adding user specific keys allows you to be notified of Password Reset requests and other user specific notifications.', CKPN_CORE_TEXT_DOMAIN ); ?>
				</td>
			</tr>

			<tr valign="top">
				<th scope="row"><?php _e( 'Send Notifications For:', CKPN_CORE_TEXT_DOMAIN ); ?><br /><span style="font-size: x-small;"><?php _e( 'What do you want to be notified of?', CKPN_CORE_TEXT_DOMAIN ); ?></span></th>
				<td>
					<input type="checkbox" name="ckpn_pushover_notifications_settings[new_user]" value="1" <?php checked( $current['new_user'], '1', true ); ?> /> 
					<label for"ckpn_pushover_notifications_settings[new_user]"><?php _e( 'New Users', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />

					<input type="checkbox" name="ckpn_pushover_notifications_settings[new_comment]" value="1" <?php checked( $current['new_comment'], '1', true ); ?> /> 
					<label for"ckpn_pushover_notifications_settings[new_comment]"><?php _e( 'New Comments', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />

					&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="ckpn_pushover_notifications_settings[notify_authors]" value="1" <?php checked( $current['notify_authors'], '1', true ); ?> /> 
					<label for="ckpn_pushover_notifications_settings[notify_authors]"><?php _e( 'Notify the Post Author (for multi-author blogs)', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />
					
					<input type="checkbox" name="ckpn_pushover_notifications_settings[password_reset]" value="1" <?php checked( $current['password_reset'], '1', true ); ?> /> 
					<label for="ckpn_pushover_notifications_settings[password_reset]"><?php _e( 'Notify users when password resets are requested for their accounts?', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />

					<input type="checkbox" name="ckpn_pushover_notifications_settings[plugin_updates]" value="1" <?php checked( $current['plugin_updates'], '1', true ); ?> /> 
					<label for="ckpn_pushover_notifications_settings[plugin_updates]"><?php _e( 'Plugin & Theme Updates are Available', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />
				</td>
			</tr>

			<?php do_action( 'ckpn_notification_checkbox_filter' ); ?>

			<tr valign="top">
				<th scope="row"><?php _e( 'Advanced &amp; Debug Options:', CKPN_CORE_TEXT_DOMAIN ); ?><br /><span style="font-size: x-small;"><?php _e( 'With great power, comes great responsiblity.', CKPN_CORE_TEXT_DOMAIN ); ?></span></th>
				<td>
					<input type="checkbox" name="ckpn_pushover_notifications_settings[sslverify]" value="1" <?php checked( $current['sslverify'], '1', true ); ?> /> 
					<label for="ckpn_pushover_notifications_settings[sslverify]"><?php _e( 'Verify SSL from api.pushover.net?', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />
					<small><?php _e( 'Disable if you get API Notification Errors in the logs. Caused when CURL cannot verify SSL Certificates', CKPN_CORE_TEXT_DOMAIN ); ?></small><br />
					
					<input type="checkbox" name="ckpn_pushover_notifications_settings[logging]" value="1" <?php checked( $current['logging'], '1', true ); ?> /> 
					<label for="ckpn_pushover_notifications_settings[logging]"><?php _e( 'Enable Logging', CKPN_CORE_TEXT_DOMAIN ); ?></label><br />
					<small><?php _e( 'Enable or Disable Logging', CKPN_CORE_TEXT_DOMAIN ); ?></small><br />
				</td>
			</tr>


			<input type="hidden" name="action" value="update" />
			<input type="hidden" name="page_options" value="ckpn_pushover_notifications_settings" />

			<?php settings_fields( 'ckpn-update-options' ); ?>
		</table>
		<input type="submit" class="button-primary" value="<?php _e( 'Save Changes', CKPN_CORE_TEXT_DOMAIN ) ?>" />
	</form>
	<div style="margin-top: 10px;">
		<sup>&dagger;</sup> <a href="#" onClick="jQuery( '#cron-help' ).toggle(); return false;"><?php _e( 'Not receiving reports?', CKPN_CORE_TEXT_DOMAIN ); ?></a><br />
		<div id="cron-help" style="display:none">
			&nbsp;&nbsp;&nbsp;&nbsp;<?php _e( 'This feature uses WP-Cron to run. If your site doesn\'t get much traffic, the scheduled task to send your reports might not execute at the specified time. There are 2 options:', CKPN_CORE_TEXT_DOMAIN ); ?><br />
			&nbsp;&nbsp;&nbsp;&nbsp;<?php printf( __( '1. You may need to use the <a href="%s" target="_blank">Improved Cron</a> plugin to help scheduled tasks run.', CKPN_CORE_TEXT_DOMAIN ), 'http://codecanyon.net/item/improved-cron/176543?ref=cklosowski' ); ?><br />
			&nbsp;&nbsp;&nbsp;&nbsp;<?php _e( '2. If you have access to create cron jobs and know how, you can use the following cron to execute wp-cron.php every hour.', CKPN_CORE_TEXT_DOMAIN ); ?><br />
			&nbsp;&nbsp;&nbsp;&nbsp;<code>0 */1 * * * GET <?php echo home_url(); ?>/wp-cron.php</code>
		</div>
	</div>
	<?php
}

function ckpn_display_logs() {
	if ( isset( $_GET['clear_logs'] ) && $_GET['clear_logs'] == 'true' ) {
		check_admin_referer( 'ckpn_clear_logs' );
		update_option( 'ckpn_logs', '' );
		$logs_cleared = true;
	}

	if ( isset( $logs_cleared ) && $logs_cleared ) {
	?><div id="setting-error-settings_updated" class="updated settings-error"><p><strong><?php _e( 'Logs Cleared', CKPN_CORE_TEXT_DOMAIN ); ?></strong></p></div><?php
	}

	$current = ckpn_get_options();
	if ( $current['logging'] == false )
		printf( '<div class="error"> <p> %s </p> </div>', esc_html__( 'Logging currently disabled.', CKPN_CORE_TEXT_DOMAIN ) );
	?>
	<a class="button gray" href="<?php echo wp_nonce_url( '?page=pushover-notifications&tab=logs&clear_logs=true', 'ckpn_clear_logs' ); ?>"><?php _e( 'Clear Logs', CKPN_CORE_TEXT_DOMAIN ); ?></a>
	<h3><?php _e( 'Logs:', CKPN_CORE_TEXT_DOMAIN ); ?></h3>
<pre>
<?php // No indent to preserve formatting
echo get_option( 'ckpn_logs' );
?>
</pre>
	<?php
}

function ckpn_display_extensions() {
	$extension_json_data = null;
	if ( false == ( $extension_json_data = get_transient( '_wp_push_extensions_listing' ) ) ) {
		$current = ckpn_get_options();
		if ( $current['sslverify'] == 0 )
			$req_args['sslverify'] = false;

		$response = wp_remote_get( 'https://wp-push.com/extensions?json=true', $req_args );
		if ( $response['response']['code'] == 200 ) {
			$extension_json_data = $response['body'];
			set_transient( '_wp_push_extensions_listing', $extension_json_data, 60*60*24);
		}
	}

	if ( $extension_json_data == null ) {
		$extension_data = __( 'Error Retreiving Extensions Feed', CKPN_CORE_TEXT_DOMAIN );
	} else {
		$extension_data = json_decode( $extension_json_data );
	}

	if ( is_array( $extension_data ) ) {
		foreach ( $extension_data as $extension ) {
			?>
			<div style="width: 300px; float: left; margin: 0 10px 10px 0">
				<a href="<?php echo $extension->link; ?>" target="_blank"><?php echo $extension->image; ?></a><br />
				<a href="<?php echo $extension->link; ?>" target="_blank"><h3><?php echo $extension->title; ?></h3></a>
				<p>
					<?php echo $extension->excerpt; ?>
				</p>
			</div>
			<?php
		}
	} else {
		echo $extension_data;
	}
}

function ckpn_display_licenses() {
	$licenses_page_options = array();
	$licenses_page_options = apply_filters( 'ckpn_licenses_array', $licenses_page_options );
	if ( isset( $_POST['action'] ) ) {
		foreach ( $licenses_page_options as $license ) {
			$license_key = $_POST[$license];
			update_option( $license, $license_key );
		}
		printf( '<div class="updated settings-error"> <p> %s </p> </div>', __( 'Licenses Saved.', CKPN_CORE_TEXT_DOMAIN ) );
	}
	?>
	<form method="post" action="<?php admin_url( 'options-general.php?page=pushover-notifications&tab=licenses' ); ?>">
		<?php wp_nonce_field( 'ckpn-update-licenses' ); ?>
		<table class="form-table">

			<?php do_action( 'ckpn_notification_licenses_page' ); ?>

			<input type="hidden" name="action" value="update" />
			<input type="hidden" name="page_options" value="<?php echo implode(',', $licenses_page_options ); ?>" />

			<?php settings_fields( 'ckpn-update-licenses' ); ?>

		</table>
		<input type="submit" class="button-primary" value="<?php _e( 'Save Licenses', CKPN_CORE_TEXT_DOMAIN ) ?>" />
	</form>
	<?php
}

function ckpn_display_sysinfo() {
	global $wpdb;
	$options = ckpn_get_options();
	if ( $options['application_key'] != false )
		$options['application_key'] = '[removed for display]';

	if ( $options['api_key'] != false )
		$options['api_key'] = '[removed for display]';

	?>
	<textarea style="font-family: Menlo, Monaco, monospace; white-space: pre" onclick="this.focus();this.select()" readonly cols="150" rows="35">
SITE_URL:                 <?php echo site_url() . "\n"; ?>
HOME_URL:                 <?php echo home_url() . "\n"; ?>

CKPN Version:             <?php echo CKPN_VERSION . "\n"; ?>
WordPress Version:        <?php echo get_bloginfo( 'version' ) . "\n"; ?>

PUSHOVER NOTIFICATIONS SETTINGS:
<?php
foreach ( $options as $name => $value ) {
if ( $value == false )
	$value = 'false';

if ( $value == '1' )
	$value = 'true';

echo $name . ': ' . $value . "\n";
}
?>

ACTIVE PLUGINS:
<?php
$plugins = get_plugins();
$active_plugins = get_option( 'active_plugins', array() );

foreach ( $plugins as $plugin_path => $plugin ) {
	// If the plugin isn't active, don't show it.
	if ( ! in_array( $plugin_path, $active_plugins ) )
		continue;

echo $plugin['Name']; ?>: <?php echo $plugin['Version'] ."\n";

}
?>

CURRENT THEME:
<?php
if ( get_bloginfo( 'version' ) < '3.4' ) {
	$theme_data = get_theme_data( get_stylesheet_directory() . '/style.css' );
	echo $theme_data['Name'] . ': ' . $theme_data['Version'];
} else {
	$theme_data = wp_get_theme();
	echo $theme_data->Name . ': ' . $theme_data->Version;
}
?>


Multi-site:               <?php echo is_multisite() ? 'Yes' . "\n" : 'No' . "\n" ?>

ADVANCED INFO:
PHP Version:              <?php echo PHP_VERSION . "\n"; ?>
MySQL Version:            <?php echo mysql_get_server_info() . "\n"; ?>
Web Server Info:          <?php echo $_SERVER['SERVER_SOFTWARE'] . "\n"; ?>

PHP Memory Limit:         <?php echo ini_get( 'memory_limit' ) . "\n"; ?>
PHP Post Max Size:        <?php echo ini_get( 'post_max_size' ) . "\n"; ?>
PHP Time Limit:           <?php echo ini_get( 'max_execution_time' ) . "\n"; ?>

WP_DEBUG:                 <?php echo defined( 'WP_DEBUG' ) ? WP_DEBUG ? 'Enabled' . "\n" : 'Disabled' . "\n" : 'Not set' . "\n" ?>

WP Table Prefix:          <?php echo "Length: ". strlen( $wpdb->prefix ); echo " Status:"; if ( strlen( $wpdb->prefix )>16 ) {echo " ERROR: Too Long";} else {echo " Acceptable";} echo "\n"; ?>

Show On Front:            <?php echo get_option( 'show_on_front' ) . "\n" ?>
Page On Front:            <?php $id = get_option( 'page_on_front' ); echo get_the_title( $id ) . ' #' . $id . "\n" ?>
Page For Posts:           <?php $id = get_option( 'page_on_front' ); echo get_the_title( $id ) . ' #' . $id . "\n" ?>

Session:                  <?php echo isset( $_SESSION ) ? 'Enabled' : 'Disabled'; ?><?php echo "\n"; ?>
Session Name:             <?php echo esc_html( ini_get( 'session.name' ) ); ?><?php echo "\n"; ?>
Cookie Path:              <?php echo esc_html( ini_get( 'session.cookie_path' ) ); ?><?php echo "\n"; ?>
Save Path:                <?php echo esc_html( ini_get( 'session.save_path' ) ); ?><?php echo "\n"; ?>
Use Cookies:              <?php echo ini_get( 'session.use_cookies' ) ? 'On' : 'Off'; ?><?php echo "\n"; ?>
Use Only Cookies:         <?php echo ini_get( 'session.use_only_cookies' ) ? 'On' : 'Off'; ?><?php echo "\n"; ?>

UPLOAD_MAX_FILESIZE:      <?php if ( function_exists( 'phpversion' ) ) echo ini_get( 'upload_max_filesize' ); ?><?php echo "\n"; ?>
POST_MAX_SIZE:            <?php if ( function_exists( 'phpversion' ) ) echo ini_get( 'post_max_size' ); ?><?php echo "\n"; ?>
WordPress Memory Limit:   <?php echo WP_MEMORY_LIMIT; ?><?php echo "\n"; ?>
DISPLAY ERRORS:           <?php echo ( ini_get( 'display_errors' ) ) ? 'On (' . ini_get( 'display_errors' ) . ')' : 'N/A'; ?><?php echo "\n"; ?>
FSOCKOPEN:                <?php echo ( function_exists( 'fsockopen' ) ) ? __( 'Your server supports fsockopen.', 'edd' ) : __( 'Your server does not support fsockopen.', 'edd' ); ?><?php echo "\n"; ?>
	</textarea>
	<?php
}